%define _use_internal_dependency_generator 0
%{!?perl_vendorlib: %define perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}

Summary: XML-SAX Perl module
Name: perl-XML-SAX
Version: 0.14
Release: 11
License: GPL or Artistic
Group: Development/Libraries
URL: http://search.cpan.org/dist/XML-SAX/
Source: ftp://cpan.org/pub/CPAN/authors/id/M/MS/MSERGEANT/XML-SAX-%{version}.tar.gz 
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: perl >= 2:5.8.0
Requires: %(perl -MConfig -le 'if (defined $Config{useithreads}) { print "perl(:WITH_ITHREADS)" } else { print "perl(:WITHOUT_ITHREADS)" }')
Requires: %(perl -MConfig -le 'if (defined $Config{usethreads}) { print "perl(:WITH_THREADS)" } else { print "perl(:WITHOUT_THREADS)" }')
Requires: %(perl -MConfig -le 'if (defined $Config{uselargefiles}) { print "perl(:WITH_LARGEFILES)" } else { print "perl(:WITHOUT_LARGEFILES)" }')
Requires: perl(:MODULE_COMPAT_%(perl -MConfig -e 'print $Config{version}'))
Source1: filter-requires-xmlsax.sh
Patch0: XML-SAX-475250.patch
# bug #641735, in upstream 0.96
Patch1: XML-SAX-0.14-Performance-fix-for-parsing-from-large-strings.patch
# bug #744200, in upstream 0.15
Patch2: perl-XML-SAX-0.14-whitespace.patch
BuildArch: noarch
BuildRequires: perl-XML-NamespaceSupport perl-XML-LibXML perl-XML-LibXML-Common

# Provide perl-specific find-{provides,requires}.
%define __find_provides /usr/lib/rpm/find-provides.perl
# %%define __find_requires /usr/lib/rpm/find-requires.perl
%define __find_requires %{SOURCE1}


%description
%{summary}.

%prep
%setup -q -n XML-SAX-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
echo N | CFLAGS="$RPM_OPT_FLAGS" perl Makefile.PL INSTALLDIRS=vendor
make OPTIMIZE="$RPM_OPT_FLAGS"

%install
rm -rf $RPM_BUILD_ROOT
make install \
  PERL_INSTALL_ROOT=$RPM_BUILD_ROOT \
  INSTALLARCHLIB=$RPM_BUILD_ROOT%{perl_archlib}
find $RPM_BUILD_ROOT -type f -a \( -name perllocal.pod -o -name .packlist \
  -o \( -name '*.bs' -a -empty \) -o \( -name '*.orig' \) \) -exec rm -f {} ';'
find $RPM_BUILD_ROOT -type d -depth -exec rmdir {} 2>/dev/null ';'
chmod -R u+w $RPM_BUILD_ROOT/*
touch $RPM_BUILD_ROOT%{perl_vendorlib}/XML/SAX/ParserDetails.ini

%check 
make test

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ ! -f "%{perl_vendorlib}/XML/SAX/ParserDetails.ini" ] ; then
  perl -MXML::SAX -e \
    'XML::SAX->add_parser(q(XML::SAX::PurePerl))->save_parsers()' 2>/dev/null || :
else
  cp -p "%{perl_vendorlib}/XML/SAX/ParserDetails.ini" "%{perl_vendorlib}/XML/SAX/ParserDetails.ini.backup"
fi

%triggerun -- perl-XML-LibXML < 1.58-8
if [ -f "%{perl_vendorlib}/XML/SAX/ParserDetails.ini.backup" ] ; then
  mv "%{perl_vendorlib}/XML/SAX/ParserDetails.ini.backup" "%{perl_vendorlib}/XML/SAX/ParserDetails.ini"
fi

%preun
if [ $1 -eq 0 ] ; then
  perl -MXML::SAX -e \
    'XML::SAX->remove_parser(q(XML::SAX::PurePerl))->save_parsers()' || :
fi
[ -f "%{perl_vendorlib}/XML/SAX/ParserDetails.ini.backup" ] && \
rm -rf "%{perl_vendorlib}/XML/SAX/ParserDetails.ini.backup" || :

%files
%defattr(-,root,root,-)
%doc Changes LICENSE README
%dir %{perl_vendorlib}/XML
%{perl_vendorlib}/XML/SAX.pm
%dir %{perl_vendorlib}/XML/SAX
%{perl_vendorlib}/XML/SAX/*.pm
%{perl_vendorlib}/XML/SAX/*.pod
%{perl_vendorlib}/XML/SAX/PurePerl
%{_mandir}/man3/XML::*.3*
%ghost %{perl_vendorlib}/XML/SAX/ParserDetails.ini
%exclude %{perl_vendorlib}/XML/SAX/placeholder.pl

%changelog
* Mon Oct 10 2011 Petr Pisar <ppisar@redhat.com> - 0.14-11
- Accept XML documents starting with white space (Resolves: #744200)

* Thu Oct 06 2011 Petr Pisar <ppisar@redhat.com> - 0.14-10
- Do not back up patched files (Related: #641735)

* Thu Oct 06 2011 Petr Pisar <ppisar@redhat.com> - 0.14-9
- Improve peformace (Resolves: #641735)

* Thu Nov 26 2009 Marcela Mašláňová <mmaslano@redhat.com> - 0.14-8
- XML-LibXML use triggers for XML::SAX update. Deleting of settings in
 ParserDetails.ini is solved by post and preun part, which create backup.
- Resolves: rhbz#536819

* Thu Nov 12 2009 Marcela Mašláňová <mmaslano@redhat.com> - 0.14-7
- post scriptlet needs to check whether the file is installed. When it isn't,
 then it's needed a call for adding PurePerl parser
 http://perl-xml.sourceforge.net/faq/#parserdetails.ini
- Resolves: rhbz#536819

* Mon Oct 19 2009 Marcela Mašláňová <mmaslano@redhat.com> - 0.14-6
- 289061 add post and preun part which should fix ghost problem
- 475250 upstream patch http://rt.cpan.org/Public/Bug/Display.html?id=26588
- Resolves: rhbz#475250, rhbz#289061

* Tue Jan 23 2007 Robin Norwood <rnorwood@redhat.com> - 0.14-5
- Resolves: #223057: try again to get the script ordering correct.

* Wed Jan 17 2007 Robin Norwood <rnorwood@redhat.com> - 0.14-4
- Resolves: #223057: incorrect use of 'return' instead of 'exit'.

* Tue Jan 09 2007 Robin Norwood <rnorwood@redhat.com> - 0.14-3
- Resolves: #210009: XML::LibXML::Common not found during upgrade

* Fri Jun 09 2006 Jason Vas Dias <jvdias@redhat.com> - 0.14-2
- fix bug 194706: fails to build under (new!) mock

* Mon Jun 05 2006 Jason Vas Dias <jvdias@redhat.com> - 0.14-1
- upgrade to 0.14

* Fri Feb 03 2006 Jason Vas Dias <jvdias@redhat.com> - 0.13-1.1
- rebuild for new perl-5.8.8

* Mon Dec 19 2005 Jason Vas Dias <jvdias@redhat.com> - 0.13-1
- upgrade to 0.13

* Fri Dec 16 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt for new gcc

* Fri Dec 16 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt for new gcj

* Sun Apr 18 2004 Ville Skyttä <ville.skytta at iki.fi> - 0.12-7
- #121167
- Handle ParserDetails.ini parser registration.
- Require perl(:MODULE_COMPAT_*).
- Own installed directories.

* Wed Oct 22 2003 Chip Turner <cturner@redhat.com> - 0.12-1
- Specfile autogenerated.

